/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import java.util.Date;

import jp.mosp.common.CommonConst;

import jp.mosp.common.bean.AuthBean;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.LogUtility;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.dto.HumanBasisDtoInterface;
import jp.mosp.common.part.DatePart;
import jp.mosp.common.part.PartManager;
import jp.mosp.common.vo.MosPLoginVo;

public class MosPAuthAction extends AuthAction {

	/**
	 * コンストラクタ
	 */
	public MosPAuthAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// パラメータの取得
		MosPLoginVo vo = (MosPLoginVo)getInitVo();
		// VO及び遷移先をセット(認証成功時に上書する)
		setVo(vo);
		setUrl(vo.getRetUrl());
		// ASPユーザー取得(設定ファイルのASP設定で判断)
		setAspUser(vo);
		// 認証処理
		login(vo);
		// 入社日をチェックする。
		checkEmployDate(vo);
		// 次のページへ遷移処理
		setNextPage(vo);
		// ユーザー情報保存
		storeUserInfo();
		// ログ出力
		LogUtility.log(request, 4, MospConst.LOG_MOSPINF, MospConst.LOG_MSG_LOGIN);
	}

	/**
	 * 認証処理
	 * @param vo ログイン画面のVO
	 */
	public void login(MosPLoginVo vo) throws Exception {
		// パラメータの取得
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DBコネクションの取得
		getConnection();
		// 認証処理
		AuthBean auth = new AuthBean(cfg, cmd, aspUser, conn, hasMospSeJar());
		auth.login(vo.getUserId(), vo.getPass());
		// 認証が失敗している場合
		if (auth.isErrMessage()) {
			// エラーメッセージの設定
			vo.addErrMessage(MospUtility.getMessage(msg, auth.getErrMessageCode(), ""));
			throw new MospException(auth.getMosPExceptionCode());
		}
		this.user = auth.getCmUserDto();
		// コミット
		commit();
	}

	/**
	 * 次ページ遷移処理
	 * @param dto			対象DTO
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void setNextPage(MosPLoginVo vo) throws Exception {
		// 初期コマンド設定
		String nextCmd = "C1060";
		// パスワード有効期限確認
		int passTerm = PartManager.mospcode(PartManager.createPartInfo(cfg, cmd, aspUser, user, conn)).getPasswordTerm();;
		boolean validPassWord = true;
		// パスワード有効期限を過ぎていたら、パスワード変更画面に遷移する。
		// ユーザーIDとパスワードが同じ場合、パスワード変更画面に遷移する。
		if (isExpirePassWord(passTerm, user.getChangePass())
				|| isDefaultPassWord(user.getUserId(), vo.getPass())	
		) {
			nextCmd = MospConst.CMD_PASS_FORCE;
			validPassWord = false;
		}
		// adminの場合CSSと初期コマンドを変更
		if (user.getAuthority().equals(CommonConst.AUTHORITY_ADMIN) && validPassWord) {
			user.setCommonCss(CommonConst.CSS_ADMIN);
			//nextCmd = vo.CMD_MENU_SYSTEM2;
			nextCmd = "S2910";
		}
		setNextCmd(nextCmd);
		// サーブレットへ
		setUrl(MospConst.URL_SRV);
	}

	/**
	 * パスワード有効期限チェック
	 * @param passTerm		有効期限期間
	 * @param updateDate	更新日時
	 * @return
	 * <p>
	 * 有効期限を超過したらtrue、そうでない場合false
	 * </p>
	 */
	private boolean isExpirePassWord(int passTerm, Date updateDate) {
		if (passTerm > 0 
				&& DatePart.getSystemDate().compareTo(DatePart.addDay(updateDate, passTerm)) > 0
		) {
			return true;
		}
		return false;
	}

	/**
	 * デフォルトパスワードチェック
	 * @param userid			対象ユーザID
	 * @param inputPassWord		対象入力パスワード
	 * @return
	 * <p>
	 * デフォルトパスワードの場合true、そうでない場合false
	 * </p>
	 * @throws Exception
	 */
	private boolean isDefaultPassWord(String userid, String inputPassWord) throws Exception {
		if (MospUtility.getDigest(MospUtility.getDigest(userid))
				.equals(MospUtility.getDigest(inputPassWord))
		) {
			return true;
		}
		return false;
	}

	/**
	 * 入社日のチェック
	 * <p>	2009/06/18	m.yoshida	mosp-base対応	</p>
	 * @throws Exception
	 */
	protected void checkEmployDate(BaseVo vo) throws Exception {
		// 入社日以降しかログインできないようにする。
		HumanBasisDtoInterface dto = PartManager.human(PartManager.createPartInfo(cfg, cmd, aspUser, user, conn)).getBasisInfo(user.getKCode());
		Date entranceDate = null;
		if (dto != null) {
			entranceDate = DatePart.convIntegerDateToDate(dto.getNyDate());
		}
		// 管理者権限の場合、人事基本情報は無い
		if (user.getAuthority().equals(CommonConst.AUTHORITY_ADMIN)) {
			entranceDate = new Date(0);
		}
		// 入社日が無いもしくは、入社日より前の場合、ログイン不可
		if (entranceDate == null
				|| DatePart.getSystemDate().compareTo(entranceDate) < 0
		) {
			// エラーメッセージの設定
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_AUTH_FAILED, ""));
			throw new MospException(MospConst.EX_AUTH_FAILED);
		}
	}
	
	protected BaseVo getInitVo() {
		return new MosPLoginVo(cfg, msg, nam, cmd, aspUser, user);
	}

	/**
	 * ASPユーザー取得(設定ファイルのASP設定で判断)
	 * @param vo			対象VO
	 * @throws Exception
	 */
	private void setAspUser(BaseVo vo) throws Exception {
		// ASPユーザー取得(設定ファイルのASP設定で判断)
		switch (MospUtility.getAspFlag(cfg)) {
		case 0:
			// 0：ASP(xユーザー:1アプリ)
		case 1:
			// 1：ASP(1ユーザー:1アプリ)
			// ASPユーザー情報をセット(セッションから取得)
			session = request.getSession(false);
			aspUser = (CmAspUserDto)session.getAttribute(MospConst.ATT_ASPUSER);
			BaseVo aspVo = (BaseVo)request.getAttribute(MospConst.ATT_VO);
			// returnUrl設定
			vo.setRetUrl(aspVo.getRetUrl());
			break;
		case 2:
			// 2：非ASP
			// ASPユーザー情報をセット(ログイン画面でのセッション切断無視)
			createAspUser();
			break;
		default:
			throw new MospException(MospConst.EX_ASP_PROPERTIES);
		}
	}

}
